VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "DieseArbeitsmappe"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = True
Option Explicit

Sub ImportAllTxt_1()
   'Alle Textdateiene eines Verzeichnisses in ein Workbook
   'jede *.txt in 1 Tabelle. Einfachste Form
   Dim Pfad As String     'Dort liegen die Textfiles
   Dim aTxt()             'Anzahl der Textdateien
   Dim AnzSh As Integer   'Anzahl der Tabellenbltter
   Dim FullName As String 'Pfad + *.txt
   Dim txtName As String  'Name der Textdatei
   Dim AnzArr As Integer  'Anzahl der Array-Eintrge
   Dim Sh2Del As Integer, Sh2Add As Integer  'Bltter lschen / zufgen
   Dim i As Integer, k As Integer
   Dim FFnr As Integer    'FreeFile-Nr.
   Dim TxtZeile As String, AnzSp As Integer
   Dim bolHeader As Boolean 'berschrift in Textdatei(en)?
   Dim SchreibZeile As Long
   Dim Tx As String
   'Fr einen Probelauf, um die Zeit des Abarbeitens festzustellen
   Dim Start, Ende

   Start = Timer
   With Application
      .ScreenUpdating = False
      .Calculation = xlCalculationManual
   End With
   On Error GoTo ErrorHandler
   'Alle Textdateien des Ordners in Array schreiben
   Pfad = "h:\ in Arbeit\TuT\Excel\TelefonExport\"
   FullName = Pfad & "*.txt"  'Evtl. anpassen auf *.csv, *.asc, 
   AnzSh = Sheets.Count
   bolHeader = True  'Existiert eine berschriftszeile bzw.
   'soll auch keine zugefgt werden?
   ReDim aTxt(1)
   aTxt(1) = Dir(FullName) 'Erste Textdatei suchen
   If aTxt(1) > "" Then    'Gefunden
      aTxt(1) = Pfad & aTxt(1) 'Vollen Pfad in Array schreiben
      Do
         txtName = Dir        'Weitere *.txt suchen
         If txtName > "" Then 'Gefunden
            AnzArr = UBound(aTxt) + 1  'Mehr Platz im Array schaffen
            ReDim Preserve aTxt(AnzArr)
            aTxt(AnzArr) = Pfad & txtName
         Else 'Rckgabe = "", alle *.txt gefunden
            Exit Do 'Schleife verlassen
         End If
      Loop
   End If
   
   'Textdateien einlesen und in getrennte Bltter speichern
   'Auf korrekte Anzahl Bltter prfen / herstellen
   If AnzSh <> AnzArr Then   'Zu viele oder zu wenig Tabellenbltter
      If AnzSh < AnzArr Then  'Bltter zufgen
         Sh2Add = AnzArr - AnzSh
         Sheets.Add after:=Sheets(Sheets.Count), Count:=Sh2Add
      Else  'Bltter lschen
         Sh2Del = AnzSh - AnzArr
         If MsgBox("Achtung, es werden " & Sh2Del & " Bltter gelscht", _
            vbYesNo + vbQuestion, "Warn-Hinweis") = vbYes Then
            'Die letzten Bltter lschen
            For i = AnzSh To AnzArr Step -1
               Sheets(i).Delete
            Next i
         Else  'Makro beenden
            MsgBox "Das Makro wird beendet, bei Bedarf neu starten!", _
            vbInformation, "Hinweis"
            Exit Sub
         End If 'MsgBox
      End If 'AnzSh <
   End If 'AnzSh <>
   
   AnzSh = Sheets.Count 'Wichtig, falls bislang <> wurde der Wert nicht gendert
   'Alle Bltter -> bei Bedarf Inhalte leeren
   For i = 1 To AnzSh
      If Application.WorksheetFunction.CountA(Sheets(i).Cells) > 0 Then _
      Sheets(i).Cells.ClearContents
   Next i

   'Jede der Text-Dateien einlesen und in getrenntes Blatt schreiben
   'Die Daten werden nicht verknpft sondern eingelesen und dann kopiert
   For i = 1 To AnzSh
      SchreibZeile = 1 + Abs(Not bolHeader)  'In Zeile 1 oder 2 schreiben?
      'Anzahl der "Spalten" im Textfile
      FFnr = FreeFile
      Open aTxt(i) For Input As #FFnr  'Textdatein zum lesen ffnen
      Line Input #FFnr, TxtZeile       'Erste Zeile lesen
      AnzSp = UBound(Split(TxtZeile, ";")) + 1  'Indirekt die Spalten zhlen
      Close #FFnr 'Text-Datei wieder schlieen

      FFnr = FreeFile
      Open aTxt(i) For Input As #FFnr  'i hat immer noch den Wert 1!
      'Erst einmal alles in Spalte A schreiben
      Do While Not EOF(FFnr)  'Jede Text-Datei
         Line Input #FFnr, TxtZeile 'Zeilenweise lesen
         Sheets(i).Cells(SchreibZeile, 1) = TxtZeile  'In Tabele schreiben
         SchreibZeile = SchreibZeile + 1
      Loop

      'In Spalten aufteilen
      Sheets(i).Columns("A:A").TextToColumns _
      Destination:=Range("A" & 1 + Abs(Not bolHeader)), _
      DataType:=xlDelimited, _
      TextQualifier:=xlDoubleQuote, _
      Semicolon:=True, _
      FieldInfo:=Array(Array(AnzSp, 1))
      Close #FFnr
      Tx = aTxt(i)
      Sheets(i).Name = myFileName(Tx, True)
   Next i 'Nchste Textdatei

ErrorHandler:
   If Err.Number <> 0 Then
   MsgBox "Fehler Nr.: " & Err.Number & vbCrLf _
   & Err.Description
   End If
   Close #FFnr
   With Application
      .ScreenUpdating = True
      .Calculate
      .Calculation = xlCalculationAutomatic
   End With
   'Spter bitte lschen
   Ende = Timer
   MsgBox Ende - Start & " Sekunden"
End Sub
  
Function myFileName(Pfad As String, Optional kuerzen As Boolean) As String
   Dim lastBS As Integer
   Dim i As Integer
   Dim Rc As Variant
   Pfad = Trim(Pfad) 'Vorsichtshalber
   Rc = Right(Pfad, Len(Pfad) - InStrRev(Pfad, "\"))
   If kuerzen Then Rc = Left(Rc, InStrRev(Rc, ".") - 1)
   myFileName = Rc
   
   'Falls in lteren VBA-Versionen 'InStrRev noch nicht verfgbar ist, dann
   'lschen Sie die beiden Programmzeilen hierber und aktivieren Sie
   'den hierunter auskommentierten Code stattdessen.
   '#########################################################
   'For i = Len(Pfad) To 1 Step -1
   'If Mid(Pfad, i, 1) = "\" Then Exit For
   'Next i
   'Rc = Trim(Mid(Pfad, i + 1, 999))
   'If kuerzen Then
   'For i = Len(Rc) To 1 Step -1
   'If Mid(Rc, i, 1) = "." Then Exit For
   'Next i
   'Rc = Left(Rc, Len(Rc) - i)
   'End If
   'myFileName = Rc
   '#########################################################
End Function

